# coding=utf-8

import sys
import shtiny_cmd

def write_data(ser, addr, data):
	print "Writing data..."

	written = 0;
	# 書き込み
	shtiny_cmd.Selection_of_user_MAT_programming(ser)
	for i in range(len(addr)):
		shtiny_cmd._128_byte_programming(ser, addr[i], data[i])
		written += len(data[i])
		sys.stdout.write("\r    %d bytes written" % written)
		sys.stdout.flush()
	print
	shtiny_cmd.end_128_byte_programming(ser)


def compare_data(ser, addr, data):
	print "Comparing data..."

	compared = 0
	# 読み込みと比較
	for i in range(len(addr)):
		read = shtiny_cmd.Memory_read(ser, addr[i], len(data[i]))
		if read != data[i]:
			raise Exception("Written and original data are different")
		compared += len(data[i])
		sys.stdout.write("\r    %d bytes compared" % compared)
		sys.stdout.flush()
	print ". OK"


def compare_checksum(ser, data, flash_size):
	print "Comparing checksums...",
	sys.stdout.flush()

	# 書き込んだはずのデータの和
	s = 0
	l = 0
	for line in data:
		for x in line:
			s += ord(x)
		l += len(line)
	s += 255 * (flash_size - l)

	# FLASHのデータの和
	checksum = shtiny_cmd.Sum_checking_of_user_MAT(ser)

	if s == checksum:
		print "OK"
	else:
		print "The checksums are different:"
		print "    sent:  %d" % s
		print "    flash: %d" % checksum
		raise Exception("Written and original data are different")

